package EarthquakeFrame;
import java.util.List;
import java.util.ArrayList;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.table.*;

import EarthquakeLib.Earthquake;
import EarthquakeLib.EarthquakeImporter;
import EarthquakeLib.EarthquakeManager;

import java.io.*;

//Kyoung Shin Park (2017 Fall)

public class EarthquakeTableFrame extends JFrame {

	//EarthquakeMapViewer map;
	EarthquakeTableModel model = null;
	
	public EarthquakeTableFrame(EarthquakeManager manager) {
		super("EarthquakeTableFrame");

		//map = new EarthquakeMapViewer(quakeList);
		//map.setVisible(true);

		this.model = new EarthquakeTableModel(manager);
		JTable table = new JTable(this.model);

		
		JTableHeader header = table.getTableHeader();
	    header.setUpdateTableInRealTime(true);
	    header.addMouseListener(model.new ColumnListener(table));
	    header.setReorderingAllowed(true);
	    
		JScrollPane scrollPane = new JScrollPane(table);
		this.add(scrollPane, BorderLayout.CENTER);

		// menu
		JMenuBar menuBar = new JMenuBar();

		// File Menu, F - Mnemonic
		JMenu fileMenu = new JMenu("File");
		fileMenu.setMnemonic(KeyEvent.VK_F);
		menuBar.add(fileMenu);
		
		// File->Open, O - Mnemonic
		JMenuItem addMenuItem = new JMenuItem("Open", KeyEvent.VK_O);
		fileMenu.add(addMenuItem);
		this.setJMenuBar(menuBar);
		addMenuItem.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
		        System.out.println("OPEN");
			}
		});
		
		// File->Exit, E - Mnemonic
		JMenuItem exitMenuItem = new JMenuItem("Exit", KeyEvent.VK_E);
		fileMenu.add(exitMenuItem);
		this.setJMenuBar(menuBar);
		exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				System.exit(0);
			}
		});

		this.setSize(600, 650);
		this.setVisible(true);
		this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	}

	public String openFile() {
		JFileChooser fileChooser = new JFileChooser();
        int returnValue = fileChooser.showOpenDialog(null);
        if (returnValue == JFileChooser.APPROVE_OPTION) {
          System.out.println("openFile");
          String selectedFilename = fileChooser.getSelectedFile().getAbsolutePath().toString();
          System.out.println(selectedFilename);
          return selectedFilename;
        }
        else {
            System.out.println("file not opened");
        	return null;
        }
	}
	

	public String saveFileDialog() {
		JFileChooser fileChooser = new JFileChooser();
        int returnValue = fileChooser.showSaveDialog(null);
        if (returnValue == JFileChooser.APPROVE_OPTION) {
          System.out.println("saveFile");
          String selectedFilename = fileChooser.getSelectedFile().getAbsolutePath().toString();
          System.out.println(selectedFilename);
          return selectedFilename;
        }
        else {
            System.out.println("file not selected");
        	return null;
        }
	}

}